﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace SxSDKCheck
{
    public partial class Form1 : Form
    {
        IntPtr[] camHandles = new IntPtr[20];
        sxInfoPack[] cameraInfo = new sxInfoPack[20];
        Int32 numberOfCameras = 0;
        UInt32 usbDll = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            textBoxInfo.AppendText("SxSDK Checker v0.03\r\n");
            usbDll = SxSDKAccess.sxGetDLLVersion();
            textBoxInfo.AppendText("SxUSB:DLL Version " + ((usbDll >> 24) & 0xFF).ToString() + "." + ((usbDll >> 16) & 0xFF).ToString() + "." + (usbDll & 0xFF).ToString() + "\r\n");
        }

        // --- Connect Button ----
        private void buttonConnect_Click_1(object sender, EventArgs e)
        {
            numberOfCameras = SxSDKAccess.sxOpen(camHandles);

            if (numberOfCameras > 0)
            {
                buttonConnect.Enabled = false;
                buttonConnect.Text = "Connected";
                textBoxInfo.AppendText("Number of cameras = " + numberOfCameras.ToString() + "\r\n\r\n");

                for (Int32 index = 0; index < numberOfCameras; index++)
                {
                    textBoxInfo.AppendText("Handle" + index.ToString() + " = " + camHandles[index].ToString() + "\r\n");
                    cameraInfo[index] = sxInfo.readInfoPack(camHandles[index]);
                    if (cameraInfo[index].result == 1)
                    {
                        // Display some of the data
                        textBoxInfo.AppendText("Firmware = " + cameraInfo[index].upperFirmwareVersion.ToString() + "."
                                             + cameraInfo[index].lowerFirmwareVersion.ToString("D2") + "\r\n");
                        textBoxInfo.AppendText("Build = " + cameraInfo[index].buildNumber.ToString() + "\r\n");
                        textBoxInfo.AppendText("Model = 0x" + cameraInfo[index].cameraModel.ToString("X2")
                                             + ", Name = " + cameraInfo[index].cameraName + "\r\n");
                        textBoxInfo.AppendText("Width = " + cameraInfo[index].imageWidth.ToString() + "\r\n");
                        textBoxInfo.AppendText("Height = " + cameraInfo[index].imageHeight.ToString() + "\r\n");
                        textBoxInfo.AppendText("Front Porch = " + cameraInfo[index].blackPixelsAtStart.ToString() + "\r\n");
                        textBoxInfo.AppendText("Back Porch = " + cameraInfo[index].blackPixelsAtEnd.ToString() + "\r\n");
                        textBoxInfo.AppendText("Fitted = ");
                        if (cameraInfo[index].hasStar2K)
                            textBoxInfo.AppendText("Star2K ");
                        if (cameraInfo[index].hasEEProm)
                            textBoxInfo.AppendText("EEprom ");
                        if (cameraInfo[index].hasGuider)
                            textBoxInfo.AppendText("Guider ");
                        if (cameraInfo[index].hasCooler)
                            textBoxInfo.AppendText("Cooler ");
                        if (cameraInfo[index].hasShutter)
                            textBoxInfo.AppendText("Shutter ");
                        textBoxInfo.AppendText("\r\n\r\n");
                    }
                }
            }
            else
                textBoxInfo.AppendText("No Sx Cameras found!\r\n");
        }

        // ---- Close any open handles on exit ----
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (numberOfCameras > 0)
            {
                for (Int32 index = 0; index >= numberOfCameras; index++)
                {
                    SxSDKAccess.sxClose(camHandles[index]);
                }
            }
        }

     }
}