﻿using System;
using System.Runtime.InteropServices;

namespace SxSDKCheck
{
// Camera Model Definitions

    public class SxSDKAccess
    {
        /**
        
        */
        [DllImport("SxUSB.dll")]
        public static extern      Int32 sxOpen([Out] IntPtr[] sxHandle);

        [DllImport("SxUSB.dll")]
        public static extern      Int32 sxClose(IntPtr sxHandle);

        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxGetFirmwareVersion(IntPtr sxHandle);

        [DllImport("SxUSB.dll")]
        internal static extern      UInt16 sxGetBuildNumber(IntPtr sxHandle);

        [DllImport("SxUSB.dll")]
        internal static extern      Int32 sxReset(IntPtr sxHandle);

        [DllImport("SxUSB.dll")]
        internal static extern      Int32 sxClearPixels(IntPtr sxHandle,
                                                        UInt16 flags,
                                                        UInt16 camIndex);

        [DllImport("SxUSB.dll")]
        internal static extern      Int32 sxLatchPixels(IntPtr sxHandle, 
                                                        UInt16 flags,
                                                        UInt16 camIndex,
                                                        UInt16 xoffset,
                                                        UInt16 yoffset,
                                                        UInt16 width,
                                                        UInt16 height,
                                                        UInt16 xbin,
                                                        UInt16 ybin);
        [DllImport("SxUSB.dll")]
        public static extern      Int32 sxExposePixels(IntPtr sxHandle,
                                                        UInt16 flags,
                                                        UInt16 camIndex,
                                                        UInt16 xoffset,
                                                        UInt16 yoffset,
                                                        UInt16 width,
                                                        UInt16 height,
                                                        UInt16 xbin,
                                                        UInt16 ybin,
                                                        UInt32 msec);
        [DllImport("SxUSB.dll")]
        internal static extern      Int32 sxExposePixelsGated(IntPtr sxHandle,
                                                        UInt16 flags,
                                                        UInt16 camIndex,
                                                        UInt16 xoffset,
                                                        UInt16 yoffset,
                                                        UInt16 width,
                                                        UInt16 height,
                                                        UInt16 xbin,
                                                        UInt16 ybin,
                                                        UInt32 msec);

        [DllImport("SxUSB.dll")]
        internal static extern      Int32 sxReadPixels(IntPtr sxHandle,
                                                        [Out] IntPtr pixels,
                                                        UInt32 count);
        [DllImport("SxUSB.dll")]
        internal static extern      Int32 sxSetShutter(IntPtr sxHandle,
                                                        UInt16 state);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxSetTimer(IntPtr sxHandle,
                                                        UInt32 msec);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxGetTimer(IntPtr sxHandle);

        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxGetCameraParams(IntPtr sxHandle,
                                                        UInt16 camIndex,
                                                        [Out] IntPtr camInfoPtr);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxSetStar2000(IntPtr sxHandle,
                                                        Byte star2K);

        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxSetSerialPort(IntPtr sxHandle,
                                                        UInt16 portIndex,
                                                        UInt16 property,
                                                        UInt32 value);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt16 sxGetSerialPort(IntPtr sxHandle,
                                                        UInt16 portIndex,
                                                        UInt16 property);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxWriteSerialPort(IntPtr sxHandle,
                                                        UInt16 portIndex,
                                                        UInt16 flush,
                                                        UInt16 count,
                                                        [Out] IntPtr data);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxReadSerialPort(IntPtr sxHandle,
                                                        UInt16 portIndex,
                                                        UInt16 count,
                                                        [Out] IntPtr data);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt16 sxGetCameraModel(IntPtr sxHandle);

        [DllImport("SxUSB.dll")]
        internal static extern      UInt16 sxGetCoolerVer(IntPtr sxHandle);

        [DllImport("SxUSB.dll")]
        internal static extern      UInt16 sxReadEEPROM(IntPtr sxHandle,
                                                        UInt16 address,
                                                        UInt16 count,
                                                        Byte[] data);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt16 sxWriteEEPROM(IntPtr sxHandle,
                                                        UInt16 address,
                                                        UInt16 count,
                                                        Byte[] data,
                                                        UInt16 adminCode);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt16 sxSetCooler(IntPtr sxHandle,
                                                        Byte status,
                                                        UInt16 SetTemp,
                                                        [Out] IntPtr RetStatus,
                                                        [Out] IntPtr RetTemp);
        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxGetSerialNumber(IntPtr sxHandle,
													    [Out] IntPtr serialNum);

        [DllImport("SxUSB.dll")]
        internal static extern      UInt32 sxSetSerialNumber(IntPtr sxHandle,
                                                        [In] IntPtr serialNum);

        [DllImport("SxUSB.dll")]
        internal static extern UInt32 sxGetDLLVersion();

    }
    // (HANDLE sxHandle, BYTE *serialNumber)
    public class sxInfo
    {
        const Byte model_MX5 = 0x45;
        const Byte model_MX5C = 0x84;
        const Byte model_MX7 = 0x47;
        const Byte model_MX7C = 0xC7;
        const Byte model_MX8C = 0xC8;
        const Byte model_MX9 = 0x49;
        const Byte model_M25C = 0x59;
        const Byte model_M26C = 0x5A;
        const Byte model_H5 = 0x05;
        const Byte model_H5C = 0x85;
        const Byte model_H9 = 0x09;
        const Byte model_H9C = 0x89;
        const Byte model_H16 = 0x10;
        const Byte model_H18 = 0x12;
        const Byte model_H35 = 0x23;
        const Byte model_H36 = 0x24;
        const Byte model_H290 = 0x58;
        const Byte model_H694 = 0x57;
        const Byte model_H674 = 0x56;
        const Byte model_H694C = 0xB7;
        const Byte model_H674C = 0xB6;
        const Byte model_SuperStarC = 0x3A;
        const Byte model_SuperStarM = 0x19;
        const Byte model_LodeStar = 0x46;
        const Byte model_CoStar = 0x17;
        const Byte model_H814 = 0x28;
        const Byte model_H814C = 0xA8;
        const Byte model_UltraStarC = 0xBC;
        const Byte model_UltraStarM = 0x3C;
        const Byte model_H825 = 0x3B;
        const Byte model_H825C = 0xBB;

        public static String getModelName(int modelNumber)
        {
            switch (modelNumber)
            {
                case model_MX5:         return("MX5");
                case model_MX5C:        return("MX5C");
                case model_MX7:         return("MX7");
                case model_MX7C:        return("MX7C");
                case model_MX8C:        return("MX8C");
                case model_MX9:         return("MX9");
                case model_M25C:        return("M25C");
                case model_M26C:        return("M26C");
                case model_H5:          return("H5");
                case model_H5C:         return("H5C");
                case model_H9:          return("H9");
                case model_H9C:         return("H9C");
                case model_H16:         return("H16");
                case model_H18:         return("H18");
                case model_H35:         return("H35");
                case model_H36:         return("H36");
                case model_H290:        return("H290");
                case model_H694:        return("H694");
                case model_H674:        return("H674");
                case model_H694C:       return("H694C");
                case model_H674C:       return("H674C");
                case model_SuperStarC:  return("SuperStarC");
                case model_SuperStarM:  return("SuperStarM");
                case model_LodeStar:    return("LodeStar");
                case model_H814:        return("H814");
                case model_H814C:       return("H814C");
                case model_UltraStarC:  return ("UltraStarC");
                case model_UltraStarM:  return ("UltraStarM");
                case model_H825:        return ("H825");
                case model_H825C:       return ("H825C");
                default:                return("Unknown");
            }
        }
        
        // Handles pointer & unmanaged memory for "readInfoPack()" 
        public static sxInfoPack readInfoPack(IntPtr camHandle)
        {
            t_sxccd_params camInfo = new t_sxccd_params();
            sxInfoPack camData = new sxInfoPack();

            // Initialize unmanged memory to hold the struct.
            IntPtr camInfoPtr = Marshal.AllocHGlobal(Marshal.SizeOf(camInfo));
            try
            {
                camData.result = (Int32)SxSDKAccess.sxGetCameraParams(camHandle, 0, camInfoPtr);
                // Copy the struct in unmanaged memory back to managed memory
                camInfo = (t_sxccd_params)Marshal.PtrToStructure(camInfoPtr, typeof(t_sxccd_params));
            }
            finally
            {
                // Release the unmanaged memory
                Marshal.FreeHGlobal(camInfoPtr);
            }

            // Transfer data from camInfo structure to camData object
            camData.imageWidth = (Int32)camInfo.width;
            camData.imageHeight = (Int32)camInfo.height;
            camData.pixelHeight = camInfo.pix_height;
            camData.pixelWidth = camInfo.pix_width;
            camData.colorMatrix = (Int32)camInfo.color_matrix;
            camData.bitsPerPixel = camInfo.bits_per_pixel;
            camData.blackPixelsAtStart = (Int32)camInfo.hfront_porch;
            camData.blackPixelsAtEnd = (Int32)camInfo.hback_porch;
            camData.blackLinesAtStart = (Int32)camInfo.vfront_porch;
            camData.blackLinesAtEnd = (Int32)camInfo.vback_porch;
            // Star2K
            if ((camInfo.extra_caps & 0x1) > 0)
                camData.hasStar2K = true;
            else
                camData.hasStar2K = false;
            // EEprom
            if ((camInfo.extra_caps & 0x4) > 0)
                camData.hasEEProm = true;
            else
                camData.hasEEProm = false;
            // Guider
            if ((camInfo.extra_caps & 0x8) > 0)
                camData.hasGuider = true;
            else
                camData.hasGuider = false;
            // Cooler
            if ((camInfo.extra_caps & 0x10) > 0)
                camData.hasCooler = true;
            else
                camData.hasCooler = false;
            // Shutter
            if ((camInfo.extra_caps & 0x20) > 0)
                camData.hasShutter = true;
            else
                camData.hasShutter = false;
            // Camera Model
            camData.cameraModel = (Int32)SxSDKAccess.sxGetCameraModel(camHandle);
            // Camera name
            camData.cameraName = getModelName(camData.cameraModel);

            // Firmware version & build number
            camData.buildNumber = 0;
            Int32 Firmware = (Int32)SxSDKAccess.sxGetFirmwareVersion(camHandle);
            camData.upperFirmwareVersion = Firmware >> 16;
            camData.lowerFirmwareVersion = Firmware & 0xFFFF;
            if (!((camData.upperFirmwareVersion < 1) || (camData.lowerFirmwareVersion < 16)))
                camData.buildNumber = (Int32)SxSDKAccess.sxGetBuildNumber(camHandle);

            return (camData);
        }
    }


    public class sxInfoPack
    {
        public Int32   imageWidth;
        public Int32   imageHeight;
        public Single  pixelWidth;
        public Single  pixelHeight;
        public Int32   colorMatrix;
        public Byte    bitsPerPixel;
        public Boolean hasStar2K;
        public Boolean hasEEProm;
        public Boolean hasGuider;
        public Boolean hasCooler;
        public Boolean hasShutter;
        public Int32   cameraModel;
        public String  cameraName;
        public Int32   blackPixelsAtStart;
        public Int32   blackPixelsAtEnd;
        public Int32   blackLinesAtStart;
        public Int32   blackLinesAtEnd;
        public Int32   upperFirmwareVersion;
        public Int32   lowerFirmwareVersion;
        public Int32   buildNumber;
        public String  serialNumber;
        public Int32   result;
    }

    // Structure to hold camera information.
    public struct t_sxccd_params
    {
        public UInt16   hfront_porch;
        public UInt16   hback_porch;
        public UInt16   width;
        public UInt16   vfront_porch;
        public UInt16   vback_porch;
        public UInt16   height;
        public Single   pix_width;
        public Single   pix_height;
        public UInt16   color_matrix;
        public Byte     bits_per_pixel;
        public Byte     num_serial_ports;
        public Byte     extra_caps;
        public Byte     vclk_delay;
    };
}
