﻿using System;
using System.Runtime.InteropServices;

namespace SxDotNet
{
    public class SxSDKAccess
    {
        /**
        
        */
        [DllImport("SxUsb.dll")]
        public static extern        Int32 sxOpen([Out] IntPtr[] sxHandle);

        [DllImport("SxUsb.dll")]
        public static extern        Int32 sxClose(IntPtr sxHandle);

        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxGetFirmwareVersion(IntPtr sxHandle);

        [DllImport("SxUsb.dll")]
        internal static extern      UInt16 sxGetBuildNumber(IntPtr sxHandle);

        [DllImport("SxUsb.dll")]
        internal static extern      Int32 sxReset(IntPtr sxHandle);

        [DllImport("SxUsb.dll")]
        internal static extern      Int32 sxClearPixels(IntPtr sxHandle,
                                                        UInt16 flags,
                                                        UInt16 camIndex);

        [DllImport("SxUsb.dll")]
        internal static extern      Int32 sxLatchPixels(IntPtr sxHandle, 
                                                        UInt16 flags,
                                                        UInt16 camIndex,
                                                        UInt16 xoffset,
                                                        UInt16 yoffset,
                                                        UInt16 width,
                                                        UInt16 height,
                                                        UInt16 xbin,
                                                        UInt16 ybin);
        [DllImport("SxUsb.dll")]
        public static extern        Int32 sxExposePixels(IntPtr sxHandle,
                                                        UInt16 flags,
                                                        UInt16 camIndex,
                                                        UInt16 xoffset,
                                                        UInt16 yoffset,
                                                        UInt16 width,
                                                        UInt16 height,
                                                        UInt16 xbin,
                                                        UInt16 ybin,
                                                        UInt32 msec);
        [DllImport("SxUsb.dll")]
        internal static extern      Int32 sxExposePixelsGated(IntPtr sxHandle,
                                                        UInt16 flags,
                                                        UInt16 camIndex,
                                                        UInt16 xoffset,
                                                        UInt16 yoffset,
                                                        UInt16 width,
                                                        UInt16 height,
                                                        UInt16 xbin,
                                                        UInt16 ybin,
                                                        UInt32 msec);

        [DllImport("SxUsb.dll")]
        internal static extern      Int32 sxReadPixels(IntPtr sxHandle,
                                                        [Out] IntPtr pixels,
                                                        UInt32 count);
        [DllImport("SxUsb.dll")]
        internal static extern      Int32 sxSetShutter(IntPtr sxHandle,
                                                        UInt16 state);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxSetTimer(IntPtr sxHandle,
                                                        UInt32 msec);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxGetTimer(IntPtr sxHandle);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxGetCameraParams(IntPtr sxHandle,
                                                        UInt16 camIndex,
                                                        [Out] IntPtr camInfoPtr);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxSetSTAR2000(IntPtr sxHandle,
                                                        Byte star2K);

        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxSetSerialPort(IntPtr sxHandle,
                                                        UInt16 portIndex,
                                                        UInt16 property,
                                                        UInt32 value);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt16 sxGetSerialPort(IntPtr sxHandle,
                                                        UInt16 portIndex,
                                                        UInt16 property);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxWriteSerialPort(IntPtr sxHandle,
                                                        UInt16 portIndex,
                                                        UInt16 flush,
                                                        UInt16 count,
                                                        [Out] IntPtr data);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxReadSerialPort(IntPtr sxHandle,
                                                        UInt16 portIndex,
                                                        UInt16 count,
                                                        [Out] IntPtr data);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt16 sxGetCameraModel(IntPtr sxHandle);

        [DllImport("SxUsb.dll")]
        internal static extern      UInt16 sxReadEEPROM(IntPtr sxHandle,
                                                        UInt16 address,
                                                        UInt16 count,
                                                        Byte[] data);
        [DllImport("SxUsb.dll")]
        internal static extern      UInt16 sxSetCooler(IntPtr sxHandle,
                                                        Byte status,
                                                        UInt16 SetTemp,
                                                        [Out] IntPtr RetStatus,
                                                        [Out] IntPtr RetTemp);

        [DllImport("SxUsb.dll")]
        internal static extern      UInt16 sxGetCoolerTemp(IntPtr sxHandle,
                                                           [Out] IntPtr RetStatus,
                                                           [Out] IntPtr RetTemp);

        [DllImport("SxUsb.dll")]
        internal static extern      UInt32 sxGetDLLVersion();

        // Flags (go in CMD_VALUE_L:H fields)
        // Wipe CCD of all accumulated charge & clear vertical + horizontal registers
        public const UInt16 CCD_WIPE_ALL = 0x00;
        // Specify odd or even field for MX cameras
        public const UInt16 CCD_FLAGS_FIELD_ODD = 0x01;
        // Specify even field for MX cameras
        public const UInt16 CCD_FLAGS_FIELD_EVEN = 0x02;
        // Specify even field for MX cameras
        public const UInt16 CCD_FLAGS_FIELD_BOTH = 0x03;
        // Was no bin accumulate flag
        public const UInt16 CCD_FLAGS_SPARE2     =	0x04;
        // Don't WIPE CDCD when clearing frame
        public const UInt16 CCD_FLAGS_NOWIPE_FRAME = 0x08;
        // Spare flag
        public const UInt16 CCD_FLAGS_SPARE4     = 0x10;
        // Implement TDI (drift scan) operation
        public const UInt16 CCD_FLAGS_TDI		  = 0x20;
        // Don't clear frame, even when asked
        public const UInt16 CCD_FLAGS_NOCLEAR_FRAME = 0x40;
        // Do not clear vertical & horizontal registers
        public const UInt16 CCD_FLAGS_NOCLEAR_REGISTER = 0x80;
        // Upper bits in byte of CCD_FLAGS word
        public const UInt16 CCD_FLAGS_SPARE8 = 0x01;
        public const UInt16 CCD_FLAGS_SPARE9 = 0x02;
        public const UInt16 CCD_FLAGS_SPARE10 = 0x04;
        public const UInt16 CCD_FLAGS_SPARE11 = 0x08;
        public const UInt16 CCD_FLAGS_SPARE12 = 0x10;
        public const UInt16 CCD_FLAGS_SHUTTER_MANUAL = 0x20;
        public const UInt16 CCD_FLAGS_SHUTTER_OPEN = 0x40;
        public const UInt16 CCD_FLAGS_SHUTTER_CLOSE = 0x80;
    }

    public class sxInfoPack
    {
        public Int32   imageWidth = 100;
        public Int32   imageHeight= 100;
        public Single  pixelWidth = 0;
        public Single  pixelHeight = 0;
        public Int32   colorMatrix = 1;
        public Byte    bitsPerPixel = 16;
        public Boolean isInterlaced = false;
        public Boolean hasStar2K = false;
        public Boolean hasEEProm = false;
        public Boolean hasGuider = false;
        public Boolean hasCooler = false;
        public Boolean hasShutter = false;
        public Int32   cameraModel = 0;
        public String  cameraName = "noCamera";
        public Int32   blackPixelsAtStart = 1;
        public Int32   blackPixelsAtEnd = 1;
        public Int32   blackLinesAtStart = 1;
        public Int32   blackLinesAtEnd = 1;
        public Int32   upperFirmwareVersion = 0;
        public Int32   lowerFirmwareVersion = 0;
        public Int32   buildNumber = 1;
        public Int32   result = 0;
    }

    public class sxExposurePack
    {
        public IntPtr  camHandle = IntPtr.Zero;
        public UInt16  flags = SxSDKAccess.CCD_FLAGS_FIELD_BOTH;
        public Boolean useGuider = false;
        public Boolean useGated = false;
        public UInt16  xOffset = 0;
        public UInt16  yOffset = 0;
        public UInt16  imageWidth = 100;
        public UInt16  imageHeight = 100;
        public UInt16  xBin = 1;
        public UInt16  yBin = 1;
        public UInt32  exposureTime = 100;
    }

    public class sxCoolerPack
    {
        public IntPtr   camHandle = IntPtr.Zero;
        public Boolean  coolerON = false;
        public Boolean  coolerState = false;
        public Single   setPoint = 0;
        public Single   currentTemperature = 20;
        public Int32    result = 0;
    }

    public class sxModels
    {
        public const Int32 H5 = 0x05;
        public const String nameH5 = "H5";
        public const Int32 H5C = 0x85;
        public const String nameH5C = "H5C";
        public const Int32 H9 = 0x09;
        public const String nameH9 = "H9";
        public const Int32 H9C = 0x89;
        public const String nameH9C = "H9C";
        public const Int32 H16 = 0x10;
        public const String nameH16 = "H16";
        public const Int32 H18 = 0x12;
        public const String nameH18 = "H18";
        public const Int32 H35 = 0x23;
        public const String nameH35 = "H35";
        public const Int32 H36 = 0x24;
        public const String nameH36 = "H36";
        public const Int32 H674 = 0x56;
        public const String nameH674 = "H674";
        public const Int32 H674C = 0xB6;
        public const String nameH674C = "H674C";
        public const Int32 H694 = 0x57;
        public const String nameH694 = "H694";
        public const Int32 H694C = 0xB7;
        public const String nameH694C = "H694C";
        public const Int32 H290 = 0x58;
        public const String nameH290 = "H290";
        public const Int32 MX5 = 0x45;
        public const String nameMX5 = "MX5";
        public const Int32 MX5C = 0x84;
        public const String nameMX5C = "MX5C";
        public const Int32 LX1 = 0x46;
        public const String nameLX1 = "LodeStar";
        public const Int32 MX7 = 0x47;
        public const String nameMX7 = "MX7";
        public const Int32 MX7C = 0xC7;
        public const String nameMX7C = "MX7C";
        public const Int32 MX8C = 0xC8;
        public const String nameMX8C = "MX8C";
        public const Int32 MX9 = 0x49;
        public const String nameMX9 = "MX9";
        public const Int32 M25C = 0x59;
        public const String nameM25C = "M25C";
        public const Int32 M26C = 0x5A;
        public const String nameM26C = "M26C";
        public const Int32 LS9 = 0x39;
        public const String nameLS9 = "Dont Know";
        public const Int32 SS9 = 0x19;
        public const String nameSS9 = "SuperStar-M";
        public const Int32 SS9C = 0x3A;
        public const String nameSS9C = "SuperStar-C";
        public const Int32 COST = 0x17;
        public const String nameCOST = "CoStar";
        public const Int32 BR694 = 0x20;
        public const String nameBR694 = "BR694";
        public const Int32 H825 = 0x3B;
        public const String nameH825 = "H825";
        public const Int32 H825C = 0xBB;
        public const String nameH825C = "H825C";
        public const Int32 USM = 0x3C;
        public const String nameUltraStarM = "UltraStar-M";
        public const Int32 USC = 0xBC;
        public const String nameUltraStarC = "UltraStar-C";

        public const Int32 MxBit = 0x40;
        public const Int32 ColourBit = 0x80;
    }

    // Structure to hold camera information.
    public struct t_sxccd_params
    {
        public UInt16   hfront_porch;
        public UInt16   hback_porch;
        public UInt16   width;
        public UInt16   vfront_porch;
        public UInt16   vback_porch;
        public UInt16   height;
        public Single   pix_width;
        public Single   pix_height;
        public UInt16   color_matrix;
        public Byte     bits_per_pixel;
        public Byte     num_serial_ports;
        public Byte     extra_caps;
        public Byte     vclk_delay;
    };

}
