﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace CsdkTester
{
    public partial class Form2 : Form
    {
 
        
        public Form2()
        {
            InitializeComponent();
        }
		// Properties
        private void Form2_Paint(object sender, PaintEventArgs e)
        {
            if (mainForm.imgFlag)
            {
                    Bitmap imageSxCam = new Bitmap(imageWidth, imageHeight, PixelFormat.Format8bppIndexed);
                    BitmapData bmpData = imageSxCam.LockBits(new Rectangle(0, 0, imageSxCam.Width, imageSxCam.Height), ImageLockMode.WriteOnly, imageSxCam.PixelFormat);
                    Int32 numBytes = bmpData.Stride * imageSxCam.Height;
                    Int32 i, j, k, index;

                    //Construct the Grayscale colour Palette
                    ColorPalette grayScalePalette = imageSxCam.Palette;
                    for (i = 0; i < 256; i++)
                        grayScalePalette.Entries[i] = Color.FromArgb(255, i, i, i);
                    imageSxCam.Palette = grayScalePalette;

                    // Take msbs of pixels (Int16) array & store in byte array for bmp data
                    Byte[] bmpBuffer = new Byte[numBytes];
                    index = 0;      // index to Int16 pixels in pixelBuffer
                    for (i = 0; i < imageSxCam.Height; i++)
                    {
                        k = i * bmpData.Stride;
                        for (j = 0; j < imageSxCam.Width; j++)
                            bmpBuffer[k++] = (Byte)(accessForm1.pixelBuffer[index++] >> 8);
                    }

                    //Copy the data from the byte array into BitmapData.Scan0
                    Marshal.Copy(bmpBuffer, 0, bmpData.Scan0, numBytes);

                    //Unlock the pixels
                    imageSxCam.UnlockBits(bmpData);

                    // Create Point for upper-left corner of image.
                    Point ulCorner = new Point(0, 0);

                    // Draw image to screen.
                    e.Graphics.DrawImage(imageSxCam, ulCorner);
                    imageSxCam.Dispose();
                    imgFlag = false;
            }

        }

    }
}
